using DinerContracts.BindingModels;
using DinerContracts.BusinessLogicsContracts;
using DinerContracts.SearchModels;
using Microsoft.Extensions.Logging;
using System.Data;

namespace Diner
{
	public partial class FormCreateOrder : Form
	{
		private readonly ILogger _logger;
		private readonly ISnackLogic _logicP;
		private readonly IOrderLogic _logicO;
		private readonly IClientLogic _logicCl;
		public FormCreateOrder(ILogger<FormCreateOrder> logger, ISnackLogic logicP, IOrderLogic logicO, IClientLogic logicCl)
		{
			InitializeComponent();
			_logger = logger;
			_logicP = logicP;
			_logicO = logicO;
			_logicCl = logicCl;
		}
		private void FormCreateOrder_Load(object sender, EventArgs e)
		{
			_logger.LogInformation("Загрузка изделий для заказа");
			try
			{
				var list = _logicP.ReadList(null);
				var listClients = _logicCl.ReadList(null);
				if (list != null)
				{
					comboBoxProduct.DisplayMember = "SnackName";
					comboBoxProduct.ValueMember = "Id";
					comboBoxProduct.DataSource = list;
					comboBoxProduct.SelectedItem = null;
				}

				if (listClients != null)
				{
					comboBoxClient.DisplayMember = "ClientFIO";
					comboBoxClient.ValueMember = "Id";
					comboBoxClient.DataSource = listClients;
					comboBoxClient.SelectedItem = null;
				}

			}
			catch (Exception ex)
			{
				_logger.LogError(ex, "Ошибка загрузки списка изделий");
				MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}
		private void CalcSum()
		{
			if (comboBoxProduct.SelectedValue != null && !string.IsNullOrEmpty(textBoxCount.Text))
			{
				try
				{
					int id = Convert.ToInt32(comboBoxProduct.SelectedIndex + 1);
					var product = _logicP.ReadElement(new SnackSearchModel
					{
						Id = id
					});
					int count = Convert.ToInt32(textBoxCount.Text);
					textBoxSum.Text = Math.Round(count * (product?.Price ?? 0), 2).ToString();
					_logger.LogInformation("Расчет суммы заказа");
				}
				catch (Exception ex)
				{
					_logger.LogError(ex, "Ошибка расчета суммы заказа");
					MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK,
					MessageBoxIcon.Error);
				}
			}
		}
		private void TextBoxCount_TextChanged(object sender, EventArgs e)
		{
			CalcSum();
		}
		private void ComboBoxProduct_SelectedIndexChanged(object sender, EventArgs e)
		{
			CalcSum();
		}
		private void ButtonSave_Click(object sender, EventArgs e)
		{
			if (string.IsNullOrEmpty(textBoxCount.Text))
			{
				MessageBox.Show("Заполните поле Количество", "Ошибка",
			   MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			if (comboBoxProduct.SelectedValue == null)
			{
				MessageBox.Show("Выберите изделие", "Ошибка",
			   MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			if (comboBoxClient.SelectedValue == null)
			{
				MessageBox.Show("Выберите заказчика", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);

				return;
			}
			_logger.LogInformation("Создание заказа");
			try
			{
				var operationResult = _logicO.CreateOrder(new OrderBindingModel
				{
					SnackId = Convert.ToInt32(comboBoxProduct.SelectedIndex + 1),
					SnackName = comboBoxProduct.SelectedValue.ToString(),
					ClientId = Convert.ToInt32(comboBoxClient.SelectedValue),
					Count = Convert.ToInt32(textBoxCount.Text),
					Sum = Convert.ToDouble(textBoxSum.Text)
				});
				if (!operationResult)
				{
					throw new Exception("Ошибка при создании заказа. Дополнительная информация в логах.");
				}
				MessageBox.Show("Сохранение прошло успешно", "Сообщение",
			   MessageBoxButtons.OK, MessageBoxIcon.Information);
				DialogResult = DialogResult.OK;
				Close();
			}
			catch (Exception ex)
			{
				_logger.LogError(ex, "Ошибка создания заказа");
				MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK,
			   MessageBoxIcon.Error);
			}
		}
		private void ButtonCancel_Click(object sender, EventArgs e)
		{
			DialogResult = DialogResult.Cancel;
			Close();
		}
	}
}
